#ifndef DISPLAY_H_
#define DISPLAY_H_

#include "freertos/FreeRTOS.h"
#include "freertos/queue.h"
#include "freertos/task.h"
#include "esp_ota_ops.h"
#include <stdio.h>
#include <iostream>
#include <iomanip>
#include <sstream>
#include <string>
#include "sdkconfig.h"
#include "Calci_Config.h"

struct display_data
{
  uint8_t p0;
  uint8_t p1;
  uint8_t p2;
  int8_t p3;
  char p4;
  uint16_t p5;
  double p6;
  char p7[25];
  char p8[25];
  double p9;
};

extern xQueueHandle display_queue;

static void display_task(void *arg);
void display_init();
std::string double_to_str(double num, int8_t precision);

void back_light(bool bg_light); // p0 = 1
void print_hello_scrn();
void select_setup();
void select_letmetry();
void show_update_popup(const char *s1);
void select_update(const char *s1);
void select_later(const char *s1);
void print_ssid(const char *ssid1, const char *ssid2, int8_t rssi, uint8_t idx, uint8_t ssid_idx);
void print_in_mode(uint8_t in_mode);
void print_psw(const char *psw, uint8_t len, uint8_t in_mode);
void print_connected_scrn();
void print_psw_in_scrn();
void print_mobile_in_scrn();
void print_otp_in_scrn();
void print_normal_mode_scrn();
void print_normal_mode_ac_scrn();
void print_screen_no(uint16_t num);
void print_operand(const char *data);
void print_operand(double data, int8_t precision);
void blank_calci_scrn();
void print_operator(char data);
void print_mem_operator(char data);
void print_result(double data);
void print_mrc_scrn(double mem_value);
void print_mobile_no(const char *mo_no, uint8_t len);
void print_otp_no(const char *otp_no, uint8_t len);
void print_main_menu(uint8_t menu_idx);
void print_main_menu(uint8_t menu_idx, const char *s1, const char *s2);
void print_gst_rate_set_screen(uint8_t gst_index, uint8_t selected, const char *menu_gst_1, const char *menu_gst_2);
void print_connecting_scrn();
void print_syncing_scrn();
void print_network_error_scrn();
void print_validating_scrn();
void print_sending_scrn();
void print_not_valid_no_scrn();
void print_connection_failed_scrn();
void print_login_again_scrn();
void print_synced_scrn();
void print_scanning();
void print_found();
void clear_operator();
void clear_mem_operator();
void print_signal_strength(int8_t rssi);
void print_try_update_again();
void print_no_update_available();
void print_checking_update();
void print_downloading(uint16_t perc);
void print_last_calculation(const char *operand_1, char sign_op, const char *operand_2);
void print_last_calculation(double operand_1, char sign_op);
void print_last_calculation(double operand_1, char sign_op, double operand_2);
void clear_last_calculation();
void print_equal_sign();
void remove_equal_perc_sign();
void print_perc_sign();
void print_gst_sign(int8_t gst_type, char key);
void print_gt_sign(uint8_t gt_op_sign);
void remove_gt_sign();
void remove_gst_sign();
void print_mem_sign(char key);
void remove_mem_sign();
void print_cash_sign(char key);
void remove_cash_sign();
void print_start_setup_scrn(uint8_t opt);
void print_battery_charge(uint8_t charge);
void print_error();
void print_in_gst(uint8_t gst_idx, const char *show_gst);
void print_in_gst(uint8_t gst_idx);
void print_system_info(uint8_t menu_idx, uint8_t selected, const char *s1, const char *s2);
void print_check_mode();
void clear_check_mode();
void print_correct_mode();
void clear_correct_mode();
void clear_operator_block();
void print_result_operator(char data);
void print_online_trans_instruct(uint8_t pay_type);
void remove_online_trans_instruct();
void print_onboarding_complete();
void print_update_done();
void print_invalid_amount_err();
void clear_invalid_amount_err();
void print_fct_rst_msg(uint8_t msg_type);
void print_sync();
void clear_sync();
void print_cust_details();
void select_cust_name();
void select_cust_num();
void select_cust_remark();
void select_cust_done();
void select_cust_pay_later();
void print_cust_details_in_name(const char *psw, uint8_t len, uint8_t in_mode);
void print_cust_details_in_num(const char *psw, uint8_t len, uint8_t in_mode);
void print_cust_details_in_remark(const char *psw, uint8_t len, uint8_t in_mode);
void print_trans_saved();
void print_instruction_scrn(uint8_t key, uint8_t select_insruct);
void print_app_qr_code();
void print_help_qr_code();
void print_trans_saved_from_main();
void remove_trans_saved_from_main();
void print_back_scrn();
void show_update_ntfy_popup(const char *s1);
void select_upd_ntfy__update();
void select_upd_ntfy_later();
void print_wifi_not_found_scrn();
void show_initializing();
void display_show_setting_menu(int show_menu, uint8_t key, const char *ssid, const char *login);
void display_show_setting_menu(int show_menu, uint8_t key, const char *ssid_login);
void display_show_setting_menu(int show_menu, uint8_t key);
void display_setting_ssid(const char *ssid1);
void display_setting_ssid(int wifi_idx, uint8_t total_wifi, uint8_t key, const char *ssid1, const char *ssid2);
void display_setting_wifi_scanning(void);
void display_err_wifi_not_connected(void);
void display_setting_log_mobile_input(void);
void display_setting_log_otp_not_valid(void);
void display_setting_log_otp_validation_failed(void);
void display_setting_log_otp_login_success(void);
void display_err_not_login(void);
void display_wifi_connected_goto_login(void);
void display_battery_low(void);
void remove_battery_charge_symbol(void);
void print_last_calculation(double operand_1, char sign_op1, double operand_2, char sign_op2, const char* ovld);
void display_trans_count(uint16_t count);
void save_current_scrn(void);
void display_error_entry_wifi(uint8_t error_select);
void display_error_entry_login(uint8_t error_select);
void display_error_wifi(uint8_t error_select);
void display_error_login(uint8_t error_select);
void display_message_when_coying_file_data_to_db(void);
void display_wait_syncing(void);
void dispaly_shutting_down(void);

void back_light(bool is_pub, bool bg_light, const uint8_t func = 1); // p0 = 1
void print_hello_scrn(bool is_pub, const uint8_t func = 2);
void select_setup(bool is_pub, const uint8_t func = 3);
void select_letmetry(bool is_pub, const uint8_t func = 4);
void show_update_popup(bool is_pub, const char *s1, const uint8_t func = 5);
void select_update(bool is_pub, const char *s1, const uint8_t func = 6);
void select_later(bool is_pub, const char *s1, const uint8_t func = 7);
void print_ssid(bool is_pub, const char *ssid1, const char *ssid2, int8_t rssi, uint8_t idx, uint8_t ssid_idx, const uint8_t func = 8);
void print_in_mode(bool is_pub, uint8_t in_mode, const uint8_t func = 9);
void print_psw(bool is_pub, const char *psw, uint8_t len, uint8_t in_mode,
               const uint8_t func = 10);
void print_connected_scrn(bool is_pub, const uint8_t func = 11);
void print_psw_in_scrn(bool is_pub, const uint8_t func = 12);
void print_mobile_in_scrn(bool is_pub, const uint8_t func = 13);
void print_otp_in_scrn(bool is_pub, const uint8_t func = 14);
void print_normal_mode_scrn(bool is_pub, const uint8_t func = 15);
void print_screen_no(bool is_pub, uint16_t num, const uint8_t func = 16);
void print_operand(bool is_pub, const char *data, const uint8_t func = 17);
void print_operand(bool is_pub, double data, int8_t precision, const uint8_t func = 48);
void blank_calci_scrn(bool is_pub, const uint8_t func = 18);
void print_operator(bool is_pub, char data, const uint8_t func = 19);
void print_mem_operator(bool is_pub, char data, const uint8_t func = 20);
void print_result(bool is_pub, double data, const uint8_t func = 21);
void print_mrc_scrn(bool is_pub, double mem_value, const uint8_t func = 22);
void print_mobile_no(bool is_pub, const char *mo_no, uint8_t len, const uint8_t func = 23);
void print_otp_no(bool is_pub, const char *otp_no, uint8_t len, const uint8_t func = 24);
void print_main_menu(bool is_pub, uint8_t menu_idx, const uint8_t func = 25);
void print_gst_rate_set_screen(bool is_pub, uint8_t gst_index, uint8_t selected, const char *menu_gst_1, const char *menu_gst_2, const uint8_t func = 26);
void print_connecting_scrn(bool is_pub, const uint8_t func = 27);
void print_syncing_scrn(bool is_pub, const uint8_t func = 28);
void print_network_error_scrn(bool is_pub, const uint8_t func = 29);
void print_validating_scrn(bool is_pub, const uint8_t func = 30);
void print_sending_scrn(bool is_pub, const uint8_t func = 31);
void print_not_valid_no_scrn(bool is_pub, const uint8_t func = 32);
void print_connection_failed_scrn(bool is_pub, const uint8_t func = 33);
void print_login_again_scrn(bool is_pub, const uint8_t func = 34);
void print_synced_scrn(bool is_pub, const uint8_t func = 35);
void print_scanning(bool is_pub, const uint8_t func = 36);
void print_found(bool is_pub, const uint8_t func = 37);
void clear_operator(bool is_pub, const uint8_t func = 38);
void clear_mem_operator(bool is_pub, const uint8_t func = 39);
void print_signal_strength(bool is_pub, int8_t rssi, const uint8_t func = 40);
void print_try_update_again(bool is_pub, const uint8_t func = 41);
void print_no_update_available(bool is_pub, const uint8_t func = 42);
void print_checking_update(bool is_pub, const uint8_t func = 43);
void print_downloading(bool is_pub, uint16_t perc, const uint8_t func = 44);
void print_last_calculation(bool is_pub, const char *operand_1, char sign_op, const char *operand_2, const uint8_t func = 45);
void print_last_calculation(bool is_pub, const char *operand_1, char sign_op, const uint8_t func = 46);
void print_last_calculation(bool is_pub, double operand_1, char sign_op, const uint8_t func = 49);
void print_last_calculation(bool is_pub, double operand_1, char sign_op, double operand_2, const uint8_t func = 50);
void clear_last_calculation(bool is_pub, const uint8_t func = 47);
void print_equal_sign(bool is_pub, const uint8_t func = 51);
void remove_equal_perc_sign(bool is_pub, const uint8_t func = 52);
void print_perc_sign(bool is_pub, const uint8_t func = 53);
void print_gst_sign(bool is_pub, int8_t gst_type, char key, const uint8_t func = 54);
void remove_gst_sign(bool is_pub, const uint8_t func = 55);
void print_mem_sign(bool is_pub, char key, const uint8_t func = 56);
void remove_mem_sign(bool is_pub, const uint8_t func = 57);
void print_cash_sign(bool is_pub, char key, const uint8_t func = 58);
void remove_cash_sign(bool is_pub, const uint8_t func = 59);
void print_start_setup_scrn(bool is_pub, uint8_t opt, const uint8_t func = 60);
void print_battery_charge(bool is_pub, uint8_t charge, const uint8_t func = 61);
void print_error(bool is_pub, const uint8_t func = 62);
void print_main_menu(bool is_pub, uint8_t menu_idx, const char *s1, const char *s2, const uint8_t func = 63);
void print_in_gst(bool is_pub, uint8_t gst_idx, const char *show_gst, const uint8_t func = 64);
void print_in_gst(bool is_pub, uint8_t gst_idx, const uint8_t func = 65);
void print_system_info(bool is_pub, uint8_t menu_idx, uint8_t selected, const char *s1, const char *s2, const uint8_t func = 66);
void print_check_mode(bool is_pub, const uint8_t func = 67);
void clear_check_mode(bool is_pub, const uint8_t func = 68);
void clear_operator_block(bool is_pub, const uint8_t func = 69);
void print_result_operator(bool is_pub, char data, const uint8_t func = 70);
void print_online_trans_instruct(bool is_pub, uint8_t pay_type, const uint8_t func = 71);
void remove_online_trans_instruct(bool is_pub, const uint8_t func = 72);
void print_gt_sign(bool is_pub, uint8_t gt_op_sign, uint8_t func = 73);
void remove_gt_sign(bool is_pub, const uint8_t func = 74);
void print_correct_mode(bool is_pub, const uint8_t func = 75);
void clear_correct_mode(bool is_pub, const uint8_t func = 76);
void print_onboarding_complete(bool is_pub, const uint8_t func = 77);
void print_update_done(bool is_pub, const uint8_t func = 78);
void print_invalid_amount_err(bool is_pub, const uint8_t func = 79);
void clear_invalid_amount_err(bool is_pub, const uint8_t func = 80);
void print_fct_rst_msg(bool is_pub, uint8_t msg_type, const uint8_t func = 81);
void print_sync(bool is_pub, const uint8_t func = 82);
void clear_sync(bool is_pub, const uint8_t func = 83);
void print_normal_mode_ac_scrn(bool is_pub, const uint8_t func = 84);
void print_cust_details(bool is_pub, const uint8_t func = 85);
void select_cust_name(bool is_pub, const uint8_t func = 86);
void select_cust_num(bool is_pub, const uint8_t func = 87);
void select_cust_remark(bool is_pub, const uint8_t func = 88);
void select_cust_done(bool is_pub, const uint8_t func = 89);
void select_cust_pay_later(bool is_pub, const uint8_t func = 90);
void print_cust_details_in_name(bool is_pub, const char *psw, uint8_t len, uint8_t in_mode, const uint8_t func = 91);
void print_cust_details_in_num(bool is_pub, const char *psw, uint8_t len, uint8_t in_mode, const uint8_t func = 92);
void print_cust_details_in_remark(bool is_pub, const char *psw, uint8_t len, uint8_t in_mode, const uint8_t func = 93);
void print_trans_saved(bool is_pub, const uint8_t func = 94);
void print_instruction_scrn(bool is_pub, uint8_t key, uint8_t select_insruct, const uint8_t func = 95);
void print_app_qr_code(bool is_pub, const uint8_t func = 96);
void print_help_qr_code(bool is_pub, const uint8_t func = 97);
void print_trans_saved_from_main(bool is_pub, const uint8_t func = 98);
void remove_trans_saved_from_main(bool is_pub, const uint8_t func = 99);
void print_back_scrn(bool is_pub, const uint8_t func = 100);
void show_update_ntfy_popup(bool is_pub, const char *s1, const uint8_t func = 101);
void select_upd_ntfy__update(bool is_pub, const uint8_t func = 102);
void select_upd_ntfy_later(bool is_pub, const uint8_t func = 103);
void print_wifi_not_found_scrn(bool is_pub, const uint8_t func = 104);
void show_initializing(bool is_pub, const uint8_t func = 105);
void display_show_setting_menu(bool is_pub, int show_menu, uint8_t key, const char *ssid, const char *login, const uint8_t func = 106);
void display_show_setting_menu(bool is_pub, int show_menu, uint8_t key, const char *ssid_login, const uint8_t func = 107);
void display_show_setting_menu(bool is_pub, int show_menu, uint8_t key, const uint8_t func = 108);
void display_setting_ssid(bool is_pub, const char *ssid1, const uint8_t func = 109);
void display_setting_ssid(bool is_pub, int wifi_idx, uint8_t total_wifi, uint8_t key, const char *ssid1, const char *ssid2, const uint8_t func = 110);
void display_setting_wifi_scanning(bool is_pub, const uint8_t func = 111);
void display_err_wifi_not_connected(bool is_pub, const uint8_t func = 112);
void display_setting_log_mobile_input(bool is_pub, const uint8_t func = 113);
void display_setting_log_otp_not_valid(bool is_pub, const uint8_t func = 114);
void display_setting_log_otp_validation_failed(bool is_pub, const uint8_t func = 115);
void display_setting_log_otp_login_success(bool is_pub, const uint8_t func = 116);
void display_err_not_login(bool is_pub, const uint8_t func = 117);
void display_wifi_connected_goto_login(bool is_pub, const uint8_t func = 118);
void display_battery_low(bool is_pub, const uint8_t func = 119);
void remove_battery_charge_symbol(bool is_pub, const uint8_t func = 120);
void print_last_calculation(bool is_pub, double operand_1, char sign_op1, double operand_2, char sign_op2, const uint8_t func=121);
void display_trans_count(bool is_pub, uint16_t count,  const uint8_t func = 122);
void save_current_scrn(bool is_pub, const uint8_t func = 123);
void display_error_entry_wifi(bool is_pub, uint8_t error_select, const uint8_t func = 124);
void display_error_entry_login(bool is_pub, uint8_t error_select, const uint8_t func = 125);
void display_error_wifi(bool is_pub, uint8_t error_select, const uint8_t func = 126);
void display_error_login(bool is_pub, uint8_t error_select, const uint8_t func = 127);
void display_message_when_coying_file_data_to_db(bool is_pub, const uint8_t func = 128);
void display_wait_syncing(bool is_pub, const uint8_t func = 129);
void dispaly_shutting_down(bool is_pub, const uint8_t func = 130);

#endif
